<sect> Installation
<p>

<sect1>
When I run mu, and I pass by the fdformat (I need to run this manually because the mulinux-fdformat asks for libc.so.5) I get this message, and I am not sure if this is a hardware-problem:
<p>
<verb>
	end_request: I/O error, dev 02:3c (floppy), sector 18
	cat: write error: Input/output error
	Done. Reboot now.
</verb>

Did you format the floppy disk with
<verb>
                        fdformat /dev/fd0H1722?
</verb>
or with a bare "fdformat /dev/fd0" ? If yes, please change media.

<sect1>
When I re-boot the PC with the installation disk inside, after a while I am told that muLinux can not be found and I am asked to specify in which partition the muLinux files are.
<p>
Ops, this is the problem: the Installer scans only the first level directories.
No problem: if you copied in
<verb>
                c:\a\b\c\d
specify:
                /a/b/c/d
</verb>
when muLinux ask for path.

<sect1>
How do you copy the muLinux files on to the floppy disk? I get the error, "insufficient disk space".
<p>

You can not copy the archives on to the floppy in such a way,
but download everything in one directory in Windows and run the
installation as specified in INSTALL.DOS, that is with the commands 
"makefd.bat" or "boot.bat"

Are you trying to *transport* this archive to the destination hard disk?

If yes, you can use the pkzip feature of multi-disk: compress all with 
pkzip (in the original machine) using the -& option. 
The obtained .zip file will be split on a set of 1.44 floppies.

Then, rebuild the archive at the destination, using pkunzip.

<sect1>
Is there a way to start muLinux with a default profile selected at startup, so that it starts and begins to work immediately?
<p>
<verb>
		setup -s lock
</verb>

<sect1>
I don't know what that 16 ramdisk stuff means, but I do know that it doesn't consume any ram.  I guess it means to have the ability to use 16 ramdisks.
<p>
Exact. This message, "16 ramdisk", is only related to the "rd" module - 
the ramdisk support in the kernel.
Everything in muLinux uses RAM, because the filesystem is in RAM, 
and executable programs use RAM.
The temporary disk (/tmp) uses its own ramdisk, with a default size 2048k. 
During the setup for /tmp the user has the possibility to change this value.

<sect1>
When I try to boot, I get memory problems (well, duh) and then when I drop down to a shell, I get "cannot fork" when attempting to make swap space.  I can't even ls or fdisk. All I can do is pwd. Any advice?
<p>

muLinux runs entirely in RAM, so it requires more RAM than usual. 
You need swap, but setting up a swap using the muLinux script is not 
possible in 4M, because the scripts fork.
You have to reach a prompt and proceed manually:
<verb>
                # .... mount a DOS disk ...
                # dd if=/dev/zero bs=1k count=4000 of=linux.swp
                # mkswap linux.swp
                # sync
                # swapon linux.swp
</verb>

<sect1>
Question: which file in the USR section causes the command history and how is it initiated?  When I don't setup USR, the command history doesn't work.  I'd like some info on this.
<p>
Take a look to the /bin/login command in muLinux: 
this is a script wrapper. It starts:
<verb>
	1. ash, if SRV  is *not* mounted (fake 'login')
	2. /usr/local/bin/login, if SRV si mounted (the true 'login')
	3. /usr/bin/ile, if USR is mounted (the command history),
</verb>
The command history in muLinux is full demanded? 
not sure what you mean "delegated" to an external program, "ile", 
used in this way:
<verb>
		# /usr/bin/ile -/etc/ilerc  /bin/-ash -si
		(this is the *fake* case). 
</verb>
If you wish to have the command history without USR, 
put "ile" in /bin, and change /bin/login accordingly.


<sect1>
Could someone tell me what arguments are available for miterm?  Are there man pages? What arguments are used for dialing a shell account?
<p>
miterm [-s speed] [-l line] [-e escape-char]
For example:
<verb>
                # miterm -l /dev/ttyS1
</verb>

After the establishing the connection with the modem, you can issue
standard AT* commands.
Try for example "ATZ". You can dial using:
<verb>
		atx3
                atdtxyz
</verb>
where xyz is the telephone number.

<sect1>
How can one reduce the required RAM, in case I want to use floppy #1 in a machine with 4MB?
<p>

If the system blocks at the message about "toilet paper", you only 
started the kernel, but the system itself won't run.
Try decreasing the ramdisk_size - when the you see the message
 "boot:" booting from floppy, type the following carefully:
<verb>
        boot: mulinux f1722 load_ramdisk=1 prompt_ramdisk=0
                ramdisk_size=3000
                ramdisk_start=597
</verb>
(on a single line)
The default value is 4600 in muLinux. You will gain 1.5M, maybe it will works.

<sect1>
The downloaded installation files are not on my notebook, but on my desktop. So I can't use boot.bat.
<p>
You can transport them to the target machine using pkzip: it can split a 
big archive on to a set of floppy disks (see instructions; multispan).

<sect1>
I got the mulinux-10r2.tgz and some modules. Now I really don't know how to get this archive on to a bootable floppy and install muLinux on to a fresh HDD.  I can extract the archive to a floppy with arc under Linux, but that floppy won't boot?  I don't use DOS or Windows.
<p>

A very common question, caused by a lack of README reading.
If you install under Linux, you have to read the file INSTALL.Linux 
and use the script "mu".

<sect1>
Why, under DOS, can I see my addon in the directory C:\Linux\X11.tgz and why NOT when I am under Linux..
<p>

YOU PUT the ADDONS in the c:\Linux directory?
Please, please! This directory is NOT for you, but reserved to UMSDOS
filesystem. Put your addons in c:\mu or c:\mulinux or c:\other!

<sect1>
muLinux works pretty well, but I always have had problems with lilo during cloning process m4_em(ext2fs).  For systems with low mem, you can't extract SRV.tgz containing lilo...  so you have to clone the basic mulinux first.
<p>
You could find the "lilo" command also in another place: it is in the
same directory you decompressed the mulinux.tgz archive. Mount this
disk and copy it in /usr/bin, before of cloning.
<p>
OUT-OF-DATE: now "lilo" is in the BASE floppy

<sect1>
I didn't understand if it is possible install new applications with Mulinux installed on hard disk. If it is possible, what I have to do?
<p>

Basically, the answer is : no. Any ELF package requires an own pool
of libraries. muLinux is a libc5, then precompiled libc6 package do not
works.

I added part of exential libc6 (from Debian 2.0) in the disk called
PERL, but if you put in muLinux some binary from recent Mandrake, they
do not works, because my libc6 is old.

I don't like battles that can't be wont [in that I'm like americans :-)]:
a little system such muLinux is, can't follow libc state-of-arts,
so as precise design muLinux will remains libc5 for a lot.

Recent libc are mega-and-mega! I thing newer Linuxes simply can't
run from a floppy disk.

<sect1>
How to add a new application in muLinux?
<p>
m4_em(answer from "winsor SMP" <em/zoot@farts.com/).
Most libc5 application can be installed within muLinux.
If you wander through the likes of metalab, you'll see many apps are
offered in two flavors, libc5 and glibc (libc6).
Using libc5 versions will get you going on the right foot, and if
you get errors about lib files you should be able to
 grab the lib files from metalab as well.
<p>
Just be sure that after installing any lib files to either run "ldconfig"
or reboot your machine(this is a VERY common mistake made)
Another more ponderous option would be to compile apps 
from the source code
using the -static flag in the makefiles........but be warned, 
this makes GIANT apps(quite similiar to the M$ stuff 8^P)
oh yeah..........and be sure to compile those apps on 
"another" linux box as the+gcc included with muLinux is for
learning C only.
)

<sect1>
After i've created a bootable floppy  (makefd) and booted again, the system goes in halt after the message: /bin/scan cannot fork (twice).
<p>
m4_em(answer from Zeimet Alex <em/lzeimet@gmx.net/)

I also once had a problem to install mulinux on a 386SX with 4MB. I
think it will not be possible to install mulinux with 4MB on a SX,
8MB are required. But installed on a HD it works with 4MB!
The trick I found: install mulinux in a UMSDOS directory on a
machine with at least 8MB, then copy the whole "linux" directory
over network on the 386. (with windows 3.11 for workgroups)
Since had I made that, I use my 386SX as a Gateway internet router
<p>
Note: It's not possible to boot with a floppy an a 386SX with less
than 8MB....or is there anybody who was able to boot with 4MB?

<sect1>
I have download X11.tgz but I can't unpack it an put it on a disk.  Using winzip, the archive only seems to contain itself (???!!) How to do ?
<p>
Recent muLinux can load addons also from a file. For example, if
the user has cloned using the UMSDOS flavor, and the archive X11.tgz is
the directory c:\mulinux (for example), it can be loaded with:

<verb>
                 setup -f X11 from=/DOS/mulinux/X11.tgz
</verb>
As alternative, if you run a muLinux release that nothing know about
the new addon, you can try using the script <em>loal</em>.

<sect1>
Is there an easy way of upgrading to the newest version of mulinux?
<p>
If you wish to upgrade to a new major release, the best thing is
to install from scratch, removing also c:\linux, if you use UMSDOS.
I know, this is a crude solution, but muLinux is full-configured,
so you lose relatively nothing.

If you only wish to upgrade some addon, you have two solution:
<verb>
        1) setup -f XYZ  from=/path/to/XYZ (XYZ is the name of the addon)
        2) use the "upgrade" script. It attempt to upgrade selectively
           only the files that are changed or new.
</verb>

I have a question/request to you: at home I have two computers, (so,
frankly speaking: 2 boxes and 1 monitor, so the second one is without
monitor, only the box.)
 often need to reach the second computer's hard disk, and I don't want to
take it out always and take it into the other computer. What I need is to
configure this one floppy linux to do everything automatically.
<p>

You have to configure muLinux on a PC with monitor. A this point, you
save the profile with "setup -s lock". At next run, muLinux do not
ask anythink. You must config mulinux with the (minimal) parameters
pertinent to destination PC.
<p>
Now, put the floppy in the destination PC without monitor and
reboot. After that, enter in it with telnet and refine the setup.

<sect1>
I would simply like to know where to put my cursor and which button to push to get to an "X11.tgz"  file?
<p>

These are the steps fo You:

1. point the url  http://sunsite.,auc.dk/mulinux
2. enter in the DOWNLOAD-AREA and follow the link "THIS SITE"
3. Now enter in the "current" directory
4. download the X11.tgz, taking care to use shift-left with the mouse

